]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
- $GET_FILES used only in get_files; optimizations engaged
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
cd445739
AM
1#!/bin/sh
2# -----------
3# $Id$
4# Exit codes:
2a5f078d 5# 0 - succesful
6# 1 - help displayed
7# 2 - no spec file name in cmdl parameters
8# 3 - spec file not stored in repo
9# 4 - some source, patch or icon files not stored in repo
10# 5 - package build failed
11# 6 - spec file with errors
12# 7 - wrong source in /etc/poldek.conf
13# 8 - Failed installing buildrequirements and subrequirements
14# 9 - Requested tag already exist
15# 10 - Refused to build fractional release
16# 100 - Unknown error (should not happen)
cd445739
AM
17
18# Notes (todo):
f7b91886 19# - builder -u fetches current version first (well that's okay, how you compare versions if you have no old spec?)
cd445739 20# - when Icon: field is present, -5 and -a5 doesn't work
f3ada241 21# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
931a4acf 22
4003ad8c 23VERSION="\
c9acaed9 24Build package utility from PLD Linux CVS repository
7304d35c 25V 0.13 (C) 1999-2005 Free Penguins".
d6a77ddb 26PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 27
cd445739 28COMMAND="build"
64ea5308 29TARGET=""
cd445739 30
bde1c404 31SPECFILE=""
d287305c 32BE_VERBOSE=""
4003ad8c 33QUIET=""
cd445739
AM
34CLEAN=""
35DEBUG=""
36NOURLS=""
37NOCVS=""
38NOCVSSPEC=""
39NODIST=""
40UPDATE=""
41UPDATE5=""
42ADD5=""
43NO5=""
44ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
c8f50498 45CVSROOT=""
cd445739
AM
46
47# It can be used i.e. in log file naming.
48# See LOGFILE example.
49DATE=`date +%Y-%m-%d_%H-%M-%S`
50
51# Example: LOGFILE='../log.$PACKAGE_NAME'
52# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
53# Yes, you can use variable name! Note _single_ quotes!
54LOGFILE=''
55
56LOGDIR=""
57LOGDIROK=""
58LOGDIRFAIL=""
59LASTLOG_FILE=""
60
61CHMOD="no"
62CHMOD_MODE="0444"
63RPMOPTS=""
64BCOND=""
65GROUP_BCONDS="no"
947025e5 66CVSIGNORE_DF="no"
d287305c 67
68PATCHES=""
69SOURCES=""
cd445739 70ICONS=""
d287305c 71PACKAGE_RELEASE=""
72PACKAGE_VERSION=""
73PACKAGE_NAME=""
cd445739
AM
74PROTOCOL="ftp"
75WGET_RETRIES=${MAX_WGET_RETRIES:-0}
76CVS_RETRIES=${MAX_CVS_RETRIES:-1000}
77
78CVSTAG=""
79RES_FILE=""
80
81CVS_SERVER="cvs.pld-linux.org"
82DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 83ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 84
36d03934 85DEF_NICE_LEVEL=19
cd445739
AM
86
87FAIL_IF_NO_SOURCES="yes"
88
18e5347d
ER
89# let get_files skip over files which are present to get those damn files fetched
90SKIP_EXISTING_FILES="no"
91
ab4a2b6e
ER
92if [ -x /usr/bin/rpm-getdeps ]; then
93 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
94else
95 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
96fi
97
cd445739
AM
98# Here we load saved user environment used to
99# predefine options set above, or passed to builder
100# in command line.
101# This one reads global system environment settings:
102if [ -f ~/etc/builderrc ]; then
103 . ~/etc/builderrc
104fi
105# And this one cascades settings using user personal
106# builder settings.
107# Example of ~/.builderrc:
108#
109#UPDATE_POLDEK_INDEXES="yes"
110#FETCH_BUILD_REQUIRES="yes"
111#REMOVE_BUILD_REQUIRES="force"
112#GROUP_BCONDS="yes"
113#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
114#
a83e5405 115SU_SUDO=""
cd445739
AM
116if [ -n "$HOME_ETC" ]; then
117 USER_CFG="$HOME_ETC/.builderrc"
118else
119 USER_CFG=~/.builderrc
120fi
121
122[ -f "$USER_CFG" ] && . "$USER_CFG"
123
06f3864d
AM
124wget --help 2>&1 | grep -q ' \-\-no-check\-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
125
ca2e6c31 126if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
127 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
128 GETURI2="$GETURI"
129 OUTFILEOPT="-O"
ca2e6c31 130elif [ -n "$USE_AXEL" ]; then
cede92b3 131 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
132 GETURI2="$GETURI"
133 OUTFILEOPT="-o"
ca2e6c31 134else
7e365483
KK
135 wget --help 2>&1 | grep -q ' \-\-inet ' && WGET_OPTS="$WGET_OPTS --inet"
136 wget --help 2>&1 | grep -q ' \-\-retry\-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
6f9a5d76 137
7e365483
KK
138 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
139 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
140 OUTFILEOPT="-O"
2bc5451f 141fi
11468b23 142
11468b23
AM
143GETLOCAL="cp -a"
144
145if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
146 RPM="rpm"
147 RPMBUILD="rpm"
148else
149 RPM="rpm"
150 RPMBUILD="rpmbuild"
151fi
152
153POLDEK_INDEX_DIR="`$RPM --eval %_rpmdir`/"
a83e5405 154POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 155
cd445739
AM
156run_poldek()
157{
158 RES_FILE=~/tmp/poldek-exit-status.$RANDOM
159 if [ -n "$LOGFILE" ]; then
160 LOG=`eval echo $LOGFILE`
161 if [ -n "$LASTLOG_FILE" ]; then
162 echo "LASTLOG=$LOG" > $LASTLOG_FILE
163 fi
040282bb 164 (nice -n ${DEF_NICE_LEVEL} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
165 return $exit_pldk
166 else
167 (nice -n ${DEF_NICE_LEVEL} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
168 return `cat ${RES_FILE}`
169 rm -rf ${RES_FILE}
170 fi
171}
172
cd445739
AM
173#---------------------------------------------
174# functions
da946cd6 175
5a491465 176usage()
177{
cd445739
AM
178 if [ -n "$DEBUG" ]; then set -xv; fi
179 echo "\
180Usage: builder [-D|--debug] [-V|--version] [-a|--as_anon] [-b|-ba|--build]
81f85806 181
cd445739
AM
182[-bb|--build-binary] [-bs|--build-source] [-u|--try-upgrade]
183[{-B|--branch} <branch>] [{-d|--cvsroot} <cvsroot>] [-g|--get]
184[-h|--help] [--http] [{-l,--logtofile} <logfile>] [-m|--mr-proper]
185[-q|--quiet] [--date <yyyy-mm-dd> [-r <cvstag>] [{-T--tag <cvstag>]
186[-Tvs|--tag-version-stable] [-Tvn|--tag-version-nest]
187[-Ts|--tag-stable] [-Tn|--tag-nest] [-Tv|--tag-version]
188[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
dfe2cb9a 189[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--show-bconds]
cd445739 190[--with/--without <feature>] [--define <macro> <value>] <package>[.spec]
2a5f078d 191
cd445739
AM
192-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
193-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
194-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
195-D, --debug - enable builder script debugging mode,
196-debug - produce rpm debug package (same as --opts -debug)
cd445739
AM
197-V, --version - output builder version
198-a, --as_anon - get files via pserver as cvs@$CVS_SERVER,
199-b, -ba, --build - get all files from CVS repo or HTTP/FTP and build package
200 from <package>.spec,
201-bb, --build-binary - get all files from CVS repo or HTTP/FTP and build binary
202 only package from <package>.spec,
c56807e0
ER
203-bp, --build-prep - execute the %prep phase of <package>.spec,
204-bc - reserved (not implemented)
205-bi reserved (not implemented)
cd445739
AM
206-bs, --build-source - get all files from CVS repo or HTTP/FTP and only pack
207 them into src.rpm,
c56807e0 208--short-circuit - reserved (not implemented)
cd445739
AM
209-B, --branch - add branch
210-c, --clean - clean all temporarily created files (in BUILD, SOURCES,
211 SPECS and \$RPM_BUILD_ROOT),
2a5f078d 212-d <cvsroot>, --cvsroot <cvsroot>
cd445739
AM
213 - setup \$CVSROOT,
214--define <macro> <value>
215 - define a macro <macro> with value <value>,
216--nodeps - rpm won't check any dependences
217-g, --get - get <package>.spec and all related files from CVS repo
218 or HTTP/FTP,
219-h, --help - this message,
220--http - use http instead of ftp,
221-l <logfile>, --logtofile <logfile>
222 - log all to file,
223-m, --mr-proper - only remove all files related to spec file and all work
224 resources,
225-nc, --no-cvs - don't download sources from CVS, if source URL is given,
226-ncs, --no-cvs-specs
227 - don't check specs in CVS
228-nd, --no-distfiles - don't download from distfiles
229-nm, --no-mirrors - don't download from mirror, if source URL is given,
230-nu, --no-urls - don't try to download from FTP/HTTP location,
231-ns, --no-srcs - don't download Sources
232-ns0, --no-source0 - don't download Source0
233-nn, --no-net - don't download anything from the net
18e5347d
ER
234-ske,
235--skip-existing-files - skip existing files in get_files
cd445739
AM
236--opts <rpm opts> - additional options for rpm
237-q, --quiet - be quiet,
238--date yyyy-mm-dd - build package using resources from specified CVS date,
239-r <cvstag>, --cvstag <cvstag>
240 - build package using resources from specified CVS tag,
241-R, --fetch-build-requires
242 - fetch what is BuildRequired,
243-RB, --remove-build-requires
244 - remove all you fetched with -R or --fetch-build-requires
245 remember, this option requires confirmation,
246-FRB, --force-remove-build-requires
247 - remove all you fetched with -R or --fetch-build-requires
248 remember, this option works without confirmation,
a7eefc54 249-sf, --source-files - list sources - bare filenames (intended for offline
250 operations; does not work when Icon field is present
251 but icon file is absent),
252-sp, --source-paths - list sources - filenames with full local paths (intended for
253 offline operations; does not work when Icon field is present
254 but icon file is absent),
2dddf439
ER
255-su, --source-urls - list urls - urls to sources and patches
256 intended for copying urls with spec with lots of macros in urls
cd445739
AM
257-T <cvstag> , --tag <cvstag>
258 - add cvs tag <cvstag> for files,
259-Tvs, --tag-version-stable
094bd95b 260 - add cvs tags STABLE and NAME-VERSION-RELEASE for files,
cd445739 261-Tvn, --tag-version-nest
1691a37b 262 - add cvs tags NEST and NAME-VERSION-RELEASE for files,
cd445739
AM
263-Ts, --tag-stable
264 - add cvs tag STABLE for files,
265-Tn, --tag-nest
266 - add cvs tag NEST for files,
267-Tv, --tag-version
1691a37b 268 - add cvs tag NAME-VERSION-RELEASE for files,
cd445739
AM
269-Tp, --tag-prefix <prefix>
270 - add <prefix> to NAME-VERSION-RELEASE tags,
271-tt, --test-tag <prefix>
272 - fail if tag is already present,
50321881
JK
273-ir, --integer-release-only
274 - allow only integer and snapshot releases
cd445739
AM
275-v, --verbose - be verbose,
276-u, --try-upgrade - check version, and try to upgrade package
277-un, --try-upgrade-with-float-version
278 - as above, but allow float version
deccc50e 279-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
280-Upi, --update-poldek-indexes
281 - refresh or make poldek package index files.
c890b916 282-np, --nopatch <patchnumber>
bed98670 283 - don't apply <patchnumber>
dfe2cb9a
MK
284--show-bconds - show available conditional builds, which can be used
285 - with --with and/or --without switches.
cd445739
AM
286--with/--without <feature>
287 - conditional build package depending on %_with_<feature>/
288 %_without_<feature> macro switch. You may now use
289 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
290 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 291--target <platform>, --target=<platform>
64ea5308 292 - build for platform <platform>.
5a491465 293"
294}
295
c890b916 296update_shell_title() {
a0d6396b 297 [ -t 1 ] || return
0b65d15e
ER
298 local len=${COLUMNS:-80}
299 local msg=$(echo "$*" | cut -c-$len)
300
f2e42a41 301 msg="builder[$SPECFILE] ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
c890b916
ER
302 case "$TERM" in
303 cygwin|xterm*)
2dddf439 304 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
c890b916
ER
305 ;;
306 screen*)
2dddf439 307 echo >&2 -ne "\033]0;$msg\007"
c890b916
ER
308 ;;
309 esac
310}
311
7e40520f
ER
312# set TARGET from BuildArch: from SPECFILE
313set_spec_target() {
314 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
315 tmp=$(awk '/^BuildArch:/ { print $NF}' $SPECFILE)
316 if [ "$tmp" ]; then
317 TARGET="$tmp"
318 case "$RPMBUILD" in
319 "rpmbuild")
320 TARGET_SWITCH="--target $TARGET" ;;
321 "rpm")
322 TARGET_SWITCH="--target=$TARGET" ;;
323 esac
324 fi
325 fi
326}
327
cd445739 328cache_rpm_dump () {
b2aeec7d
AM
329 if [ -n "$DEBUG" ]; then
330 set -x;
331 set -v;
332 fi
7e40520f 333
cd445739
AM
334rpm_dump_cache=`
335 case "$RPMBUILD" in
336 rpm )
2a5f078d 337 rpm -bp --nodeps --define 'prep %dump' $BCOND $TARGET_SWITCH $SPECFILE 2>&1
cd445739
AM
338 ;;
339 rpmbuild )
2f810e46 340 rpmbuild --nodigest --nosignature --define 'prep %dump' $BCOND $TARGET_SWITCH $SPECFILE 2>&1
cd445739
AM
341 ;;
342 esac`
343}
344
345rpm_dump () {
346 if [ -z "$rpm_dump_cache" ] ; then
347 echo "internal error: cache_rpm_dump not called!" 1>&2
348 fi
349 echo "$rpm_dump_cache"
350}
351
59398507 352parse_spec()
353{
af4d5315 354 update_shell_title "parsing specfile"
cd445739
AM
355 if [ -n "$DEBUG" ]; then
356 set -x;
357 set -v;
358 fi
b2975fc3 359
cd445739 360 cd $SPECS_DIR
4ca52257 361
cd445739 362 cache_rpm_dump
00fcec7e 363
cd445739
AM
364 if [ "$NOSRCS" != "yes" ]; then
365 SOURCES="`rpm_dump | awk '/SOURCEURL[0-9]+/ {print $3}'`"
366 fi
367 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
368 FAIL_IF_NO_SOURCES="no"
369 fi
370
371 PATCHES="`rpm_dump | awk '/PATCHURL[0-9]+/ {print $3}'`"
372 ICONS="`awk '/^Icon:/ {print $2}' ${SPECFILE}`"
373 PACKAGE_NAME="`$RPM -q --qf '%{NAME}\n' --specfile ${SPECFILE} 2> /dev/null | head -n 1`"
374 PACKAGE_VERSION="`$RPM -q --qf '%{VERSION}\n' --specfile ${SPECFILE} 2> /dev/null| head -n 1`"
375 PACKAGE_RELEASE="`$RPM -q --qf '%{RELEASE}\n' --specfile ${SPECFILE} 2> /dev/null | head -n 1`"
376
341603cf 377# These variables may be unset after first cache_rpm_dump call
378# (because of not-yet-retrieved icon file)
379#
380# if [ -z "$PACKAGE_NAME" -o -z "$PACKAGE_VERSION" -o -z "$PACKAGE_RELEASE" ]; then
381# Exit_error err_no_package_data;
382# fi
78eab2a1 383
cd445739
AM
384 if [ -n "$BE_VERBOSE" ]; then
385 echo "- Sources : `nourl $SOURCES`"
386 if [ -n "$PATCHES" ]; then
387 echo "- Patches : `nourl $PATCHES`"
388 else
389 echo "- Patches : *no patches needed*"
390 fi
391 if [ -n "$ICONS" ]; then
392 echo "- Icon : `nourl $ICONS`"
393 else
394 echo "- Icon : *no package icon*"
395 fi
396 echo "- Name : $PACKAGE_NAME"
397 echo "- Version : $PACKAGE_VERSION"
398 echo "- Release : $PACKAGE_RELEASE"
399 fi
400}
401
402Exit_error()
403{
404 if [ -n "$DEBUG" ]; then
405 set -x;
406 set -v;
407 fi
408
409 cd "$__PWD"
410
411 case "$1" in
412 "err_no_spec_in_cmdl" )
413 remove_build_requires
414 echo "ERROR: spec file name not specified.";
415 exit 2 ;;
416 "err_no_spec_in_repo" )
417 remove_build_requires
418 echo "Error: spec file not stored in CVS repo.";
419 exit 3 ;;
420 "err_no_source_in_repo" )
421 remove_build_requires
422 echo "Error: some source, patch or icon files not stored in CVS repo. ($2)";
423 exit 4 ;;
424 "err_build_fail" )
425 remove_build_requires
426 echo "Error: package build failed. (${2:-no more info})";
427 exit 5 ;;
78eab2a1
AM
428 "err_no_package_data" )
429 remove_build_requires
430 echo "Error: couldn't get out package name/version/release from spec file."
431 exit 6 ;;
50321881
JK
432 "err_tag_exists" )
433 remove_build_requires
434 echo "Tag ${2} already exists (spec release: ${3}).";
435 exit 9 ;;
436 "err_fract_rel" )
437 remove_build_requires
438 echo "Release ${2} not integer and not a snapshot.";
439 exit 10 ;;
fb96e0b5
AM
440 "err_branch_exists" )
441 remove_build_requires
442 echo "Tree branch already exists (${2}).";
443 exit 11 ;;
50321881 444
cd445739 445 esac
50321881 446 echo "Unknown error."
2a5f078d 447 exit 100
cd445739
AM
448}
449
450init_builder()
451{
452 if [ -n "$DEBUG" ]; then
453 set -x;
454 set -v;
0dd6320d 455 fi
cd445739
AM
456
457 SOURCE_DIR="`$RPM --eval '%{_sourcedir}'`"
458 SPECS_DIR="`$RPM --eval '%{_specdir}'`"
459
460 __PWD="`pwd`"
00fcec7e 461}
462
d6a77ddb 463get_spec()
1471f6d6 464{
c890b916 465
2e5be021 466 update_shell_title "get_spec"
c890b916 467
cd445739
AM
468 if [ -n "$DEBUG" ]; then
469 set -x;
470 set -v;
471 fi
472
473 cd "$SPECS_DIR"
049ab214 474 if [ ! -f "$SPECFILE" ]; then
cd445739
AM
475 SPECFILE="`basename $SPECFILE .spec`.spec";
476 fi
477 if [ "$NOCVSSPEC" != "yes" ]; then
cd445739 478
049ab214
ER
479 if [ ! -s CVS/Root -a "$NOCVSSPEC" != "yes" ]; then
480 echo "Warning: No CVS access defined - using local .spec file"
481 NOCVSSPEC="yes"
cd445739
AM
482 fi
483
049ab214 484 cvsup "$SPECFILE" || Exit_error err_no_spec_in_repo
cd445739 485 fi
049ab214 486
cd445739
AM
487 if [ ! -f "$SPECFILE" ]; then
488 Exit_error err_no_spec_in_repo;
489 fi
490
491 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
492 chmod $CHMOD_MODE $SPECFILE
493 fi
494 unset OPTIONS
a7eefc54 495 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $SPECFILE
7e40520f
ER
496
497 set_spec_target
cd445739
AM
498}
499
500find_mirror()
501{
502 cd "$SPECS_DIR"
503 url="$1"
504 if [ ! -f "mirrors" -a "$NOCVSSPEC" != "yes" ] ; then
505 cvs update mirrors >&2
506 fi
507
508 IFS="|"
509 while read origin mirror name rest
510 do
511 ol=`echo -n "$origin"|wc -c`
512 prefix="`echo -n "$url" | head -c $ol`"
513 if [ "$prefix" = "$origin" ] ; then
514 suffix="`echo "$url"|cut -b $ol-`"
515 echo -n "$mirror$suffix"
516 return 0
517 fi
518 done < mirrors
519 echo "$url"
520}
521
522src_no ()
523{
524 cd $SPECS_DIR
525 rpm_dump | \
526 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
527 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
528 head -n 1 | xargs
1471f6d6 529}
530
cd445739 531src_md5 ()
8ba5cdda 532{
cd445739
AM
533 [ X"$NO5" = X"yes" ] && return
534 no=$(src_no "$1")
535 [ -z "$no" ] && return
536 cd $SPECS_DIR
47a8df12 537 spec_rev=$(grep $SPECFILE CVS/Entries 2>/dev/null | sed -e s:/$SPECFILE/:: -e s:/.*::)
cd445739
AM
538 if [ -z "$spec_rev" ]; then
539 spec_rev="$(head -n 1 $SPECFILE | sed -e 's/.*\$Revision: \([0-9.]*\).*/\1/')"
540 fi
541 spec="$SPECFILE[0-9.,]*,$(echo $spec_rev | sed 's/\./\\./g')"
542 md5=$(grep -s -v '^#' additional-md5sums | \
543 grep -E "[ ]$(basename "$1")[ ]+${spec}([ ,]|\$)" | \
544 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
545 grep -E '^[0-9a-f]{32}$')
546 if [ X"$md5" = X"" ] ; then
6203ea52
AG
547 source_md5=`grep -i "#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
548 if [ ! -z "$source_md5" ] ; then
7e365483 549 echo $source_md5;
6203ea52 550 else
7e365483
KK
551 # we have empty SourceX-md5, but it is still possible
552 # that we have NoSourceX-md5 AND NoSource: X
553 nosource_md5=`grep -i "#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
554 if [ ! -z "$nosource_md5" -a ! X"`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" = X"" ] ; then
555 echo $nosource_md5;
556 fi;
6203ea52 557 fi;
cd445739
AM
558 else
559 if [ $(echo "$md5" | wc -l) != 1 ] ; then
560 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
561 fi
562 echo "$md5" | tail -n 1
563 fi
564}
565
566distfiles_url ()
567{
1246dc2a 568 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
cd445739
AM
569}
570
571distfiles_attic_url ()
572{
1246dc2a 573 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
cd445739
AM
574}
575
576good_md5 ()
577{
578 md5=$(src_md5 "$1")
579 [ "$md5" = "" ] || \
580 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
581}
582
a4b50627
AF
583good_size ()
584{
deccc50e
AM
585 size="$(find $(nourl "$1") -printf "%s" 2>/dev/null)"
586 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
587}
588
947025e5 589cvsignore_df ()
590{
591 if [ "$CVSIGNORE_DF" != "yes" ]; then
592 return
593 fi
594 cvsignore=${SOURCE_DIR}/.cvsignore
595 if ! grep -q "^$1\$" $cvsignore 2> /dev/null; then
596 echo "$1" >> $cvsignore
597 fi
598}
599
e7fa3b9f
ER
600cvsup()
601{
602 update_shell_title "cvsup"
603 local OPTIONS="up "
604 if [ -n "$CVSROOT" ]; then
605 OPTIONS="-d $CVSROOT $OPTIONS"
e7fa3b9f 606 fi
b1c6aace 607
e7fa3b9f
ER
608 if [ -z "$CVSDATE" -a -z "$CVSTAG" ]; then
609 OPTIONS="$OPTIONS -A"
610 else
611 if [ -n "$CVSDATE" ]; then
612 OPTIONS="$OPTIONS -D $CVSDATE"
613 fi
614 if [ -n "$CVSTAG" ]; then
615 OPTIONS="$OPTIONS -r $CVSTAG"
616 fi
617 fi
618
619 local result=1
620 local retries_counter=0
621 update_shell_title "cvsup: $# files"
622 while [ "$result" != "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; do
623 retries_counter=$(( $retries_counter + 1 ))
624 output=$(LC_ALL=C cvs $OPTIONS "$@" 2>&1)
625 result=$?
626 [ -n "$output" ] && echo "$output"
627 if (echo "$output" | grep -qE "(Cannot connect to|connect to .* failed|Connection reset by peer|Connection timed out|Unknown host)") && [ "$result" -ne "0" -a "$retries_counter" -le "$CVS_RETRIES" ]; then
628 echo "Trying again [$*]... ($retries_counter)"
629 update_shell_title "cvsup: retry #$retries_counter"
630 sleep 2
631 continue
632 else
633 break
634 fi
635 done
636 update_shell_title "cvsup: done!"
049ab214 637 return $result
e7fa3b9f
ER
638}
639
cd445739
AM
640get_files()
641{
af4d5315 642 update_shell_title "fetching sources"
cd445739
AM
643
644 if [ -n "$DEBUG" ]; then
645 set -x;
646 set -v;
647 fi
648
f09c0772 649 if [ $# -gt 0 ]; then
cd445739
AM
650 cd "$SOURCE_DIR"
651
b1c6aace 652 if [ ! -s CVS/Root -a "$NOCVS" != "yes" ]; then
049ab214 653 echo "Warning: No CVS access defined for SOURCES"
b1c6aace
ER
654 NOCVS="yes"
655 fi
656
f2e42a41 657 local nc=0
e7fa3b9f 658 local get_files_cvs=""
3815b69a 659 for i in "$@"; do
f2e42a41 660 nc=$((nc + 1))
3815b69a 661 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 662 update_shell_title "$i"
f09c0772
ER
663 local fp=`nourl "$i"`
664 if [ -f "$fp" ] && [ "$SKIP_EXISTING_FILES" = "yes" ]; then
18e5347d
ER
665 continue
666 fi
cd445739
AM
667 if [ -n "$UPDATE5" ]; then
668 if [ -n "$ADD5" ]; then
f09c0772 669 [ "$fp" = "$i" ] && continue
cd445739
AM
670 grep -qiE '^#[ ]*Source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE && continue
671 else
672 grep -qiE '^#[ ]*Source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE || continue
673 fi
674 fi
675 FROM_DISTFILES=0
f09c0772 676 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
677 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
678 echo "Warning: no URL given for $i"
679 fi
680
681 if [ -n "$(src_md5 "$i")" ] && [ -z "$NODIST" ]; then
a4b50627 682 if good_md5 "$i" && good_size "$i"; then
deccc50e 683 echo "$(nourl "$i") having proper md5sum already exists"
cd445739
AM
684 continue
685 fi
686 target=$(nourl "$i")
687 url=$(distfiles_url "$i")
688 url_attic=$(distfiles_attic_url "$i")
689 FROM_DISTFILES=1
33da77c4 690 if [ "`echo $url | grep -E '^(\.|/)'`" ]; then
18a52930 691 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
692 ${GETLOCAL} $url $target
693 else
694 if [ -z "$NOMIRRORS" ]; then
695 url="`find_mirror "$url"`"
696 fi
18a52930 697 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 698 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 699 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 700 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 701 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
702 fi
703 fi
704 if ! test -s "$target"; then
705 rm -f "$target"
706 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 707 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
708 ${GETLOCAL} $url_attic $target
709 else
710 if [ -z "$NOMIRRORS" ]; then
711 url_attic="`find_mirror "$url_attic"`"
712 fi
18a52930 713 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 714 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 715 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
18a52930 716 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 717 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
718 fi
719 fi
720 fi
947025e5 721 if test -s "$target"; then
722 cvsignore_df $target
723 else
cd445739
AM
724 rm -f "$target"
725 FROM_DISTFILES=0
726 fi
727 elif [ -z "$(src_md5 "$i")" -a "$NOCVS" != "yes" ]; then
e7fa3b9f
ER
728 get_files_cvs="$get_files_cvs $fp"
729 continue
cd445739
AM
730 fi
731
f09c0772 732 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739
AM
733 if [ -z "$NOMIRRORS" ]; then
734 im="`find_mirror "$i"`"
735 else
736 im="$i"
737 fi
18a52930 738 update_shell_title "${GETURI%% *}: $im"
cd445739 739 ${GETURI} "$im" || \
33da77c4 740 if [ "`echo $im | grep -E 'ftp://'`" ]; then
18a52930 741 update_shell_title "${GETURI2%% *}: $im"
cd445739 742 ${GETURI2} "$im"
7e365483 743 fi
cd445739
AM
744 fi
745
746 fi
747 srcno=$(src_no $i)
f09c0772 748 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
cd445739
AM
749 Exit_error err_no_source_in_repo $i;
750 elif [ -n "$UPDATE5" ] && \
751 ( ( [ -n "$ADD5" ] && echo $i | grep -q -E 'ftp://|http://|https://' && \
752 [ -z "$(grep -E -i '^NoSource[ ]*:[ ]*'$i'([ ]|$)' $SPECS_DIR/$SPECFILE)" ] ) || \
753 grep -q -i -E '^#[ ]*source'$(src_no $i)'-md5[ ]*:' $SPECS_DIR/$SPECFILE )
754 then
deccc50e 755 echo "Updating source-$srcno md5."
f09c0772 756 md5=$(md5sum "$fp" | cut -f1 -d' ')
cd445739 757 perl -i -ne '
deccc50e
AM
758 print unless /^\s*#\s*Source'$srcno'-md5\s*:/i;
759 print "# Source'$srcno'-md5:\t'$md5'\n"
cd445739
AM
760 if /^Source'$srcno'\s*:\s+/;
761 ' \
762 $SPECS_DIR/$SPECFILE
763 fi
2a5f078d 764
a4b50627 765 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
766 :
767 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 768 # wrong md5 from distfiles: remove the file and try again
cd445739 769 # but only once ...
deccc50e 770 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
771 FROM_DISTFILES=2
772 rm -f $target
18a52930 773 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 774 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 775 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 776 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 777 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
778 fi
779 if ! test -s "$target"; then
780 rm -f "$target"
18a52930 781 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 782 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 783 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
18a52930 784 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 785 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
786 fi
787 fi
788 test -s "$target" || rm -f "$target"
789 fi
790
a4b50627 791 if good_md5 "$i" && good_size "$i" ; then
cd445739
AM
792 :
793 else
deccc50e
AM
794 echo "MD5 sum mismatch or 0 size. Use -U to refetch sources,"
795 echo "or -5 to update md5 sums, if you're sure files are correct."
cd445739
AM
796 Exit_error err_no_source_in_repo $i
797 fi
798 done
e7fa3b9f
ER
799 SHELL_TITLE_PREFIX=""
800
801 if [ "$get_files_cvs" ]; then
802 cvsup $get_files_cvs
803 fi
cd445739
AM
804
805 if [ "$CHMOD" = "yes" ]; then
3815b69a 806 CHMOD_FILES="`nourl "$@"`"
cd445739
AM
807 if [ -n "$CHMOD_FILES" ]; then
808 chmod $CHMOD_MODE $CHMOD_FILES
809 fi
810 fi
cd445739
AM
811 fi
812}
813
814make_tagver() {
78eab2a1
AM
815
816 if [ -n "$DEBUG" ]; then
817 set -x;
818 set -v;
819 fi
2a5f078d 820
cd445739
AM
821 # Check whether first character of PACKAGE_NAME is legal for tag name
822 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
823 TAG_PREFIX=tag_
824 fi
825 TAGVER=$TAG_PREFIX$PACKAGE_NAME-`echo $PACKAGE_VERSION | sed -e "s/\./\_/g" -e "s/@/#/g"`-`echo $PACKAGE_RELEASE | sed -e "s/\./\_/g" -e "s/@/#/g"`
826 # Remove #kernel.version_release from TAGVER because tagging sources
827 # could occur with different kernel-headers than kernel-headers used at build time.
828 TAGVER=$(echo "$TAGVER" | sed -e 's/#.*//g')
829 echo -n "$TAGVER"
830}
831
832tag_files()
833{
834 TAG_FILES="$@"
835
836 if [ -n "$DEBUG" ]; then
837 set -x;
838 set -v;
839 fi
840
841 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
842 echo "Version: $PACKAGE_VERSION"
843 echo "Release: $PACKAGE_RELEASE"
844
845 TAGVER=`make_tagver`
846
847 if [ "$TAG_VERSION" = "yes" ]; then
848 echo "CVS tag: $TAGVER"
849 fi
850 if [ -n "$TAG" ]; then
851 echo "CVS tag: $TAG"
852 fi
853
854 OPTIONS="tag -F"
855 if [ -n "$CVSROOT" ]; then
856 OPTIONS="-d $CVSROOT $OPTIONS"
857 fi
858
859 cd "$SOURCE_DIR"
860 for i in $TAG_FILES
861 do
862 # don't tag files stored on distfiles
863 [ -n "`src_md5 $i`" ] && continue
864 if [ -f "`nourl $i`" ]; then
865 if [ "$TAG_VERSION" = "yes" ]; then
866 cvs $OPTIONS $TAGVER `nourl $i`
867 fi
868 if [ -n "$TAG" ]; then
869 cvs $OPTIONS $TAG `nourl $i`
870 fi
871 else
872 Exit_error err_no_source_in_repo $i
873 fi
874 done
875
876 cd "$SPECS_DIR"
877 if [ "$TAG_VERSION" = "yes" ]; then
878 cvs $OPTIONS $TAGVER $SPECFILE
879 fi
880 if [ -n "$TAG" ]; then
881 cvs $OPTIONS $TAG $SPECFILE
882 fi
883
884 unset OPTIONS
885 fi
886}
887
888branch_files()
889{
890 TAG=$1
891 echo "CVS branch tag: $TAG"
892 shift;
893
894 TAG_FILES="$@"
895
896 if [ -n "$DEBUG" ]; then
897 set -x;
898 set -v;
899 fi
900
901 if [ -n "$1$2$3$4$5$6$7$8$9${10}" ]; then
902
903 OPTIONS="tag -b"
904 if [ -n "$CVSROOT" ]; then
905 OPTIONS="-d $CVSROOT $OPTIONS"
906 fi
907 cd "$SOURCE_DIR"
908 for i in $TAG_FILES
909 do
910 if [ -f `nourl $i` ]; then
911 cvs $OPTIONS $TAG `nourl $i`
912 else
913 Exit_error err_no_source_in_repo $i
914 fi
915 done
916 cd "$SPECS_DIR"
917 cvs $OPTIONS $TAG $SPECFILE
918
919 unset OPTIONS
920 fi
921}
922
923
924
59398507 925build_package()
926{
2e5be021 927 update_shell_title "build_package"
cd445739
AM
928 if [ -n "$DEBUG" ]; then
929 set -x;
930 set -v;
931 fi
5a491465 932
cd445739
AM
933 cd "$SPECS_DIR"
934
935 if [ -n "$TRY_UPGRADE" ]; then
2e5be021 936 update_shell_title "build_package: try_upgrade"
cd445739 937 if [ -n "$FLOAT_VERSION" ]; then
cc538c24 938 TNOTIFY=`./pldnotify.awk $SPECFILE -n` || exit 1
cd445739 939 else
cc538c24 940 TNOTIFY=`./pldnotify.awk $SPECFILE` || exit 1
cd445739
AM
941 fi
942
943 TNEWVER=`echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }'`
944
945 if [ -n "$TNEWVER" ]; then
946 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
947 echo "New version found, updating spec file to version " $TNEWVER
948 cp -f $SPECFILE $SPECFILE.bak
949 chmod +w $SPECFILE
950 eval "perl -pi -e 's/Version:\t"$TOLDVER"/Version:\t"$TNEWVER"/gs' $SPECFILE"
f7b91886 951 eval "perl -pi -e 's/Release:\t[1-9]{0,4}/Release:\t0.1/' $SPECFILE"
cd445739 952 parse_spec;
7f347798 953 if [ -n "$ICONS" ]; then
954 get_files $ICONS;
955 parse_spec;
956 fi
f7b91886 957 NODIST="yes" UPDATE5="yes" get_files "$SOURCES $PATCHES";
cd445739
AM
958 unset TOLDVER TNEWVER TNOTIFY
959 fi
960 fi
961 cd "$SPECS_DIR"
2a5f078d 962
cd445739
AM
963 case "$COMMAND" in
964 build )
965 BUILD_SWITCH="-ba" ;;
966 build-binary )
967 BUILD_SWITCH="-bb" ;;
968 build-source )
969 BUILD_SWITCH="-bs --nodeps" ;;
970 build-prep )
971 BUILD_SWITCH="-bp --nodeps" ;;
972 esac
c890b916 973
2e5be021 974 update_shell_title "build_package: $COMMAND"
cd445739
AM
975 if [ -n "$LOGFILE" ]; then
976 LOG=`eval echo $LOGFILE`
977 if [ -d "$LOG" ]; then
978 echo "Log file $LOG is a directory."
979 echo "Parse error in the spec?"
980 Exit_error err_build_fail;
981 fi
982 if [ -n "$LASTLOG_FILE" ]; then
983 echo "LASTLOG=$LOG" > $LASTLOG_FILE
984 fi
985 RES_FILE=~/tmp/$RPMBUILD-exit-status.$RANDOM
21bc1a97 986 (time eval nice -n ${DEF_NICE_LEVEL} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $TARGET_SWITCH $SPECFILE; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739
AM
987 RETVAL=`cat $RES_FILE`
988 rm $RES_FILE
989 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
990 if [ "$RETVAL" -eq "0" ]; then
991 mv $LOG $LOGDIROK
992 else
993 mv $LOG $LOGDIRFAIL
994 fi
995 fi
8ba5cdda 996 else
8f96ab6c 997 eval nice -n ${DEF_NICE_LEVEL} $RPMBUILD $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $BCOND $TARGET_SWITCH $SPECFILE
cd445739 998 RETVAL=$?
8ba5cdda 999 fi
cd445739
AM
1000 if [ "$RETVAL" -ne "0" ]; then
1001 if [ -n "$TRY_UPGRADE" ]; then
1002 echo "\n!!! Package with new version cannot be build automagically\n"
1003 mv -f $SPECFILE.bak $SPECFILE
1004 fi
1005 Exit_error err_build_fail;
1006 fi
1007 unset BUILD_SWITCH
1008}
1009
1010nourl()
1011{
1012 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1013}
1014
cd445739
AM
1015install_required_packages()
1016{
1017 run_poldek -vi $1
1018 return $?
1019}
1020
1021set_bconds_values()
1022{
0b65d15e 1023 update_shell_title "set bcond values"
c890b916 1024
cd445739
AM
1025 AVAIL_BCONDS_WITHOUT=""
1026 AVAIL_BCONDS_WITH=""
1027 if `grep -q ^%bcond ${SPECFILE}`; then
1028 BCOND_VERSION="NEW"
36d03934 1029 elif `egrep -q ^#\ *_with ${SPECFILE}`; then
cd445739
AM
1030 BCOND_VERSION="OLD"
1031 else
1032 BCOND_VERSION="NONE"
1033 fi
301cbfd4
ER
1034
1035 # expand bconds from ~/.bcondrc
1036 # The file structure is like gentoo's package.use:
1037 # ---
1038 # * -selinux
1039 # samba -mysql -pgsql
47a8df12 1040 # w32codec-installer license_agreement
301cbfd4
ER
1041 # php +mysqli
1042 # ---
c8a3e2ac 1043 if [ "${BCOND_VERSION}" != "NONE" ] && ( [ -f $HOME/.bcondrc ] || ( [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] ) ) ; then
301cbfd4
ER
1044 # This takes package name, first defined in spec.
1045 # so consider that when defining flags for package.
1046 PN=`$RPM -q --qf '%{NAME}\n' --specfile $SPECFILE | head -n 1`
3e1cbfe0 1047 SN=${SPECFILE%%\.spec}
301cbfd4
ER
1048 AVAIL=`$RPMBUILD --bcond $SPECFILE`
1049
c8a3e2ac
AG
1050 BCONDRC=$HOME/.bcondrc
1051 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && BCONDRC=$HOME_ETC/.bcondrc
1052
301cbfd4
ER
1053 while read pkg flags; do
1054 # ignore comments
1055 [[ "$pkg" == \#* ]] && continue
1056
1057 # any package or current package?
3e1cbfe0 1058 if [ "$pkg" = "*" ] || [ "$pkg" = "$PN" ] || [ "$pkg" = "$SN" ]; then
301cbfd4
ER
1059 for flag in $flags; do
1060 opt=${flag#[+-]}
1061
1062 # use only flags which are in this package.
1063 if [[ $AVAIL = *${opt}* ]]; then
3b5101f0
ER
1064 if [[ $flag = -* ]]; then
1065 BCOND="$BCOND --without $opt"
301cbfd4 1066 else
3b5101f0 1067 BCOND="$BCOND --with $opt"
301cbfd4
ER
1068 fi
1069 fi
1070 done
1071 fi
c8a3e2ac 1072 done < $BCONDRC
301cbfd4
ER
1073 fi
1074
cd445739
AM
1075 case "${BCOND_VERSION}" in
1076 NONE)
7e365483 1077 :
cd445739 1078 ;;
7e365483 1079 OLD)
cd445739
AM
1080 echo "Warning: This spec has old style bconds. Fix it || die."
1081 for opt in `$RPMBUILD --bcond $SPECFILE |grep ^_without_`
1082 do
1083 AVAIL_BCOND_WITHOUT=`echo $opt|sed -e "s/^_without_//g"`
1084 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1085 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1086 else
1087 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1088 fi
1089 done
2a5f078d 1090
cd445739
AM
1091 for opt in `$RPMBUILD --bcond $SPECFILE |grep ^_with_`
1092 do
1093 AVAIL_BCOND_WITH=`echo $opt|sed -e "s/^_with_//g"`
1094 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1095 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1096 else
1097 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1098 fi
1099 done
1100 ;;
1101 NEW)
1102 cond_type="" # with || without
1103 for opt in `$RPMBUILD --bcond $SPECFILE`
1104 do
1105 case "$opt" in
1106 _without)
1107 cond_type="without"
1108 ;;
1109 _with)
1110 cond_type="with"
1111 ;;
f8d24cee 1112 _without_*)
1113 AVAIL_BCOND_WITHOUT="`echo $opt | sed 's/^_without_//g'`"
1114 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1115 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1116 else
1117 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1118 fi
1119 ;;
1120 _with_*)
1121 AVAIL_BCOND_WITH="`echo $opt | sed 's/^_with_//g'`"
1122 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1123 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1124 else
1125 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1126 fi
1127 ;;
cd445739
AM
1128 *)
1129 case "$cond_type" in
1130 with)
1131 cond_type=''
1132 AVAIL_BCOND_WITH="$opt"
1133 if `echo $BCOND|grep -q -- "--with $AVAIL_BCOND_WITH"`;then
1134 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$AVAIL_BCOND_WITH>"
1135 else
1136 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $AVAIL_BCOND_WITH"
1137 fi
7e365483 1138 ;;
cd445739
AM
1139 without)
1140 cond_type=''
1141 AVAIL_BCOND_WITHOUT="$opt"
1142 if `echo $BCOND|grep -q -- "--without $AVAIL_BCOND_WITHOUT"`;then
1143 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$AVAIL_BCOND_WITHOUT>"
1144 else
1145 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $AVAIL_BCOND_WITHOUT"
1146 fi
1147 ;;
1148 esac
1149 ;;
1150 esac
1151 done
1152 ;;
1153 esac
1154}
1155
1156run_sub_builder()
1157{
1158 package_name="${1}"
af6b168f 1159 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1160 #
1161